with Ada.Command_Line;
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Ada.Text_IO;use Ada.Text_IO;
with Ada.Strings.Unbounded.Text_IO; use Ada.Strings.Unbounded.Text_IO;
--with Ada.Integers.IO; use Ada.Integers.IO;
package body Concread is

   task body Concurrent_Read
   is
      U: Unbounded_String;
      F: File_Type;
      Name_Error: exception;
   begin
      Put_Line(Integer'Image(My_Id)&":""This is an example of concurrent use I/O. Notice I'll sleep until a rendez-vous occurs");
      Put_Line(Integer'Image(My_Id)&":""I hope you will carefully read my sources before accusing any Ada implementation of any mistake");
      accept Filetoread (Filename:String) do
         Open(F,In_File,Filename);
      end Filetoread;
      loop
         exit when End_Of_File(F);
         U:=Get_Line(F);
         Put_Line(U);
      end loop;
      Close(F);
      for I in 1..100000 loop
         Put_Line(Integer'Image(My_Id)&":"&Integer'Image(I));
         Put_Line(Integer'Image(My_Id)&"=> And Remember: Ada should not be blamed for your mistakes");
         Put_Line(Integer'Image(My_Id)&"=> And indeed no compiler should be blamed for programmer's misconceptions");

      end loop;
   exception
      when E: Name_Error =>
         Put_Line("Cannot Open Input File : "&Ada.Command_Line.Argument(1));
         raise;
      when others => null;
   end Concurrent_Read;

end Concread;
